       module Module11
       implicit none
       save 

! adding in lat lat2 lon lon2 as parameters

integer, parameter :: NumParams = 44
integer,parameter ::                   cPL_HD    = 1
integer,parameter ::                   cPL_HD2   = 2
integer,parameter ::                   cPL_CRS   = 3
integer,parameter ::                   cPL_CRS2   = 4
integer,parameter ::                   cPL_CRS3   = 5
integer,parameter ::                   cPL_SPD = 6
integer,parameter ::                   cPL_SPD2 = 7
integer,parameter ::                   cPL_SPD3 = 8
integer,parameter ::                   cPL_WDIR = 9
integer,parameter ::                   cPL_WSPD = 10
integer,parameter ::                   cPL_WDIR2 =11
integer,parameter ::                   cPL_WSPD2 = 12
integer,parameter ::                   cPL_WDIR3 = 13
integer,parameter ::                   cPL_WSPD3 = 14
integer,parameter ::                   cDIR      = 15
integer,parameter ::                   cSPD      = 16
integer,parameter ::                   cDIR2     = 17
integer,parameter ::                   cSPD2     = 18
integer,parameter ::                   cDIR3     = 19
integer,parameter ::                   cSPD3     = 20
integer,parameter ::                   cP        = 21
integer,parameter ::                   ctemperature = 22
integer,parameter ::                   ctemperature2= 23
integer,parameter ::                   ctemperature3= 24
integer,parameter ::                   cT        = 25
integer,parameter ::                   cT2       = 26
integer,parameter ::                   cTW       = 27
integer,parameter ::                   cTW2 =      28
integer,parameter ::                   cTD =          29
integer,parameter ::                   cTD2 =         30
integer,parameter ::                   cRH =          31
integer,parameter ::                   cRH2 =         32
integer,parameter ::                   cPRECIP =      33
integer,parameter ::                   cRAD  =        34
integer,parameter ::                   cRAD2 =        35
integer,parameter ::                   cRAD3 =        36
integer,parameter ::                   cQ   =         37
integer, parameter ::                  cQ2 =          38
integer, parameter ::                  cRRATE =       39
integer, parameter ::                  clatitude =    40
integer, parameter ::                  clatitude2 =   41
integer, parameter ::                  clongitude =   42
integer, parameter ::                  clongitude2 =  43 
integer, parameter ::                  cNONE =        44

character (Len=12), dimension(NumParams) :: parnames
      !
!     the names for the netcdf paramaters that can come for a ship

contains

  subroutine initparnames()
      parnames(cPL_HD) =                 'PL_HD       '
      parnames(cPL_HD2) =                'PL_HD2      '
      parnames(cPL_CRS) =                'PL_CRS      '
      parnames(cPL_CRS2) =               'PL_CRS2     '
      parnames(cPL_CRS3) =               'PL_CRS3     '
      parnames(cPL_SPD) =                'PL_SPD      '
      parnames(cPL_SPD2) =               'PL_SPD2     '
      parnames(cPL_SPD3) =               'PL_SPD3     '
      parnames(cPL_WDIR) =               'PL_WDIR     '
      parnames(cPL_WSPD) =               'PL_WSPD     '
      parnames(cPL_WDIR2) =              'PL_WDIR2    '
      parnames(cPL_WSPD2) =              'PL_WSPD2    '
      parnames(cPL_WDIR3) =              'PL_WDIR3    '
      parnames(cPL_WSPD3) =              'PL_WSPD3    '
      parnames(cDIR) =                   'DIR         '
      parnames(cSPD) =                   'SPD         '
      parnames(cDIR2) =                  'DIR2        '
      parnames(cSPD2) =                  'SPD2        '
      parnames(cDIR3) =                  'DIR3        '
      parnames(cSPD3) =                  'SPD3        '
      parnames(cP) =                     'P           '
      parnames(ctemperature) =           'temperature '
      parnames(ctemperature2) =          'temperature2'
      parnames(ctemperature3) =          'temperature3'
      parnames(cT) =                     'T           '
      parnames(cT2) =                    'T2          '
      parnames(cTW) =                    'TW          '
      parnames(cTW2) =                   'TW2         ' 
      parnames(cTD) =                    'TD          '
      parnames(cTD2) =                   'TD2         '
      parnames(cRH) =                    'RH          '
      parnames(cRH2) =                   'RH2         '
      parnames(cPRECIP) =                'PRECIP      '
      parnames(cRAD) =                   'RAD         '
      parnames(cRAD2) =                  'RAD2        '
      parnames(cRAD3) =                  'RAD3        '
      parnames(cQ) =                     'Q           '
      parnames(cQ2) =                    'Q2          '
      parnames(cRRATE) =                 'RRATE       '
      parnames(clatitude) =              'clatitude   '
      parnames(clatitude2) =             'clatitude2  '
      parnames(clongitude) =             'clongitude  '
      parnames(clongitude2) =            'clongitude2 '
      parnames(cNONE) =                  'NONE        '

      return
      end subroutine 

! this is new for version 11
! I would have loved to use the first one in Module8 but barrett uses
! somewhat different names so I copied it and put it here where
! I will revise
   !
  subroutine Sndinitparn()
      parnames(cPL_HD) =                 'HD          '
      parnames(cPL_HD2) =                'HD2         '
      parnames(cPL_CRS) =                'CR          '
      parnames(cPL_CRS2) =               'CR2         '
      parnames(cPL_CRS3) =               'CR3         '
      parnames(cPL_SPD) =                'SS          '
      parnames(cPL_SPD2) =               'SS2         '
      parnames(cPL_SPD3) =               'SS3         '
      parnames(cPL_WDIR) =               'RD          '
      parnames(cPL_WSPD) =               'RS          '
      parnames(cPL_WDIR2) =              'RD2         '
      parnames(cPL_WSPD2) =              'RS2         '
      parnames(cPL_WDIR3) =              'RD3         '
      parnames(cPL_WSPD3) =              'RS3         '
      parnames(cDIR) =                   'WD          '
      parnames(cSPD) =                   'WS          '
      parnames(cDIR2) =                  'WD2         '
      parnames(cSPD2) =                  'WS2         '
      parnames(cDIR3) =                  'WD3         '
      parnames(cSPD3) =                  'WS3         '
      parnames(cP) =                     'PA          '
      parnames(ctemperature) =           'TS          '
      parnames(ctemperature2) =          'TS2         '
      parnames(ctemperature3) =          'TS3         '
      parnames(cT) =                     'TA          '
      parnames(cT2) =                    'TA2         '
      parnames(cTW) =                    'TW          '
      parnames(cTW2) =                   'TW2         ' 
      parnames(cTD) =                    'TD          '
      parnames(cTD2) =                   'TD2         '
      parnames(cRH) =                    'RH          '
      parnames(cRH2) =                   'RH2         '
      parnames(cPRECIP) =                'PRECIP      '
      parnames(cRAD) =                   'RAD         '
      parnames(cRAD2) =                  'RAD2        '
      parnames(cRAD3) =                  'RAD3        '
      parnames(cQ) =                     'Q           '
      parnames(cQ2) =                    'Q2          '
      parnames(cRRATE) =                 'RRATE       '
      parnames(clatitude) =              'LA          '
      parnames(clatitude2) =             'LA2         '
      parnames(clongitude) =             'LO          '
      parnames(clongitude2) =            'LO2         '
      parnames(cNONE) =                  'NONE        '

      return
      end subroutine

      end module Module11
