      USE netcdf_inc
      USE Module11
      implicit none

! NOTE:  This code has been considerably alter from James Lamm's original code.
!	 All major changes are denoted by introductory and closing !!!'s.  Some
!	 other minor changes may not be marked, so this is version of the code
!	 needs to be used as it is the only one that works inline w/mkcoapsimma
!	 correctly.  
!	 - Barrett Olafson

!     This program reads a list of netcdf files for a cruse and
!     outputs up to 11 values which can be used for later processing
!     for each hour.  Later appended to also provide attribute
!     info such as heights.

!!!!!!!!!!!!!!! VERSION HISTORY  !!!!   VERSION HISTORY !!!!!!!!

!  We had a version 10 which was to do with making
!  12 values (rare case) keep moving on rather than stopping
!  and having to manually
!  take out a repeated minute.  (The only way to get 12 values
!  for an 11 minutes span.)

! This version 11 is about storing info from convers_units for
! Barrett.

! Version 12 is to make conver much more like heights all the
! way through and sometimes take 'type' rather than convers_units
! for temperatures (ST).  See notes taken from board in Red folder.
! Also cleaning up code a little bit, sprucing comments.


!!!!!!TO RUN !!!!!!!!!!!!!TO RUN !!!!!!!!!!!!!!!!!!TO RUN !!!!!!!!!!!!!!!!!!!!

!     Will run this from subdirectory RunPlace by saying "../Reads12.exec 
!     filelisting" where filelisting is a list of netcdf files in a cruise, one
!     name per line.

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


      logical, parameter :: DebugOn = .false.

      integer convtime, yesno

      integer iji,iji2,iji3
       ! 
!     just general purpose counters

      real :: DegreesToRadians = 0.0174533
       !
!     multiply your degree value by this to get radians which 
!     is what FORTRAN sin, cos work from

      character let

!     these are values stored in version 200 netcdf files at COAPS
!     The size of each file can vary but it should be <= 1440

      integer, allocatable, dimension(:) :: time
      character, allocatable, dimension(:) :: timeflags

      real, allocatable, dimension(:) :: latitude
      character, allocatable, dimension(:) :: latitudeflags

      real, allocatable, dimension(:) :: latitude2
      character, allocatable, dimension(:) :: latitude2flags


      real, allocatable, dimension(:) :: longitude
      character, allocatable, dimension(:) :: longitudeflags

      real, allocatable, dimension(:) :: longitude2
      character, allocatable, dimension(:) :: longitude2flags

      real, allocatable, dimension(:) ::      PL_HD
      character, allocatable, dimension(:) :: PL_HDflags
        !
!     integer,parameter ::                   cPL_HD    = 1
!
!     declared in module but give one sample here to show
!     how done for all variables.
!     the constants for lat/lon vars start at 40

      real, allocatable, dimension(:) ::      PL_HD2
      character, allocatable, dimension(:) :: PL_HD2flags

      real, allocatable, dimension(:) ::      PL_CRS
      character, allocatable, dimension(:) :: PL_CRSflags

      real, allocatable, dimension(:) ::      PL_CRS2
      character, allocatable, dimension(:) :: PL_CRS2flags

      real, allocatable, dimension(:) ::      PL_CRS3
      character, allocatable, dimension(:) :: PL_CRS3flags

      real, allocatable, dimension(:) ::      PL_SPD
      character, allocatable, dimension(:) :: PL_SPDflags

      real, allocatable, dimension(:) ::      PL_SPD2
      character, allocatable, dimension(:) :: PL_SPD2flags

      real, allocatable, dimension(:) ::      PL_SPD3
      character, allocatable, dimension(:) :: PL_SPD3flags
      
      real, allocatable, dimension(:) ::      PL_WDIR
      character, allocatable, dimension(:) :: PL_WDIRflags

      real, allocatable, dimension(:) ::      PL_WSPD
      character, allocatable, dimension(:) :: PL_WSPDflags

      real, allocatable, dimension(:) ::      PL_WDIR2
      character, allocatable, dimension(:) :: PL_WDIR2flags

      real, allocatable, dimension(:) ::      PL_WSPD2
      character, allocatable, dimension(:) :: PL_WSPD2flags

      real, allocatable, dimension(:) ::      PL_WDIR3
      character, allocatable, dimension(:) :: PL_WDIR3flags

      real, allocatable, dimension(:) ::      PL_WSPD3
      character, allocatable, dimension(:) :: PL_WSPD3flags

      real, allocatable, dimension(:) ::      DIR
      character, allocatable, dimension(:) :: DIRflags

      real, allocatable, dimension(:) ::      SPD
      character, allocatable, dimension(:) :: SPDflags

      real, allocatable, dimension(:) ::      DIR2
      character, allocatable, dimension(:) :: DIR2flags

      real, allocatable, dimension(:) ::      SPD2
      character, allocatable, dimension(:) :: SPD2flags

      real, allocatable, dimension(:) ::      DIR3
      character, allocatable, dimension(:) :: DIR3flags

      real, allocatable, dimension(:) ::      SPD3
      character, allocatable, dimension(:) :: SPD3flags

      real, allocatable, dimension(:) ::      P
      character, allocatable, dimension(:) :: Pflags

      real, allocatable, dimension(:) ::      temperature
      character, allocatable, dimension(:) :: temperatureflags

      real, allocatable, dimension(:)      :: temperature2
      character, allocatable, dimension(:) :: temperature2flags

      real, allocatable, dimension(:)      :: temperature3
      character, allocatable, dimension(:) :: temperature3flags

      real, allocatable, dimension(:) ::      T
      character, allocatable, dimension(:) :: Tflags

      real, allocatable, dimension(:) ::      T2
      character, allocatable, dimension(:) :: T2flags

      real, allocatable, dimension(:) ::      TW
      character, allocatable, dimension(:) :: TWflags

      real, allocatable, dimension(:) ::      TW2
      character, allocatable, dimension(:) :: TW2flags

      real, allocatable, dimension(:) ::      TD
      character, allocatable, dimension(:) :: TDflags

      real, allocatable, dimension(:) ::      TD2
      character, allocatable, dimension(:) :: TD2flags

      real, allocatable, dimension(:) ::      RH
      character, allocatable, dimension(:) :: RHflags

      real, allocatable, dimension(:) ::      RH2
      character, allocatable, dimension(:) :: RH2flags

      real, allocatable, dimension(:) ::      PRECIP
      character, allocatable, dimension(:) :: PRECIPflags

      real, allocatable, dimension(:) ::      RAD
      character, allocatable, dimension(:) :: RADflags


      real, allocatable, dimension(:) ::      RAD2
      character, allocatable, dimension(:) :: RAD2flags

      real, allocatable, dimension(:) ::      RAD3
      character, allocatable, dimension(:) :: RAD3flags

      real, allocatable, dimension(:) ::      Q
      character, allocatable, dimension(:) :: Qflags

      real, allocatable, dimension(:) ::      Q2
      character, allocatable, dimension(:) :: Q2flags

      real, allocatable, dimension(:) ::      RRATE
      character, allocatable, dimension(:) :: RRATEflags


      real, allocatable, dimension(:) ::      NONE
      character, allocatable, dimension(:) :: NONEflags
      !
!     this NONE stuff is special.  It is there to have one that
!     never really is in the netcdf file just to see how things
!     turn out when that is the case.  It is there to make programs
!     easy to debug in that we now don't have to 'artificially' make
!     it seem like a variable is not there to test that case or look up
!     in files to find a variable the ship does not have

      real :: r1, r2, r3, r4

      integer :: yr, mo, dy, hr, min, zerotime

      integer :: byr, bmo, bdy, bhr, bmin,bsec

!     unit number for OutputFile where we put data to

      integer :: OutputFile = 34

      integer :: HInfo = 39
      !
!     short for Height Information file

      integer :: CInfo = 49
      !
!     New for V. 12, where the convert units info goes.


!*********************************************************
!

      integer, parameter :: NameLength = 300

      integer, parameter :: MMaxFiles = 3000

      character (Len=NameLength), dimension (MMaxFiles) :: FileNames
      !
!     Filnames stores the names of the files of a netcdf cruise.
!     These file names should be listed in the file given in the
!     command line that calls this program.  There shouldn't
!     be more than (NMaxFiles - 1) on a cruise.

      integer :: count, i, j, k, L, m, m
       !
!     count holds the number of netcdf files in cruise

      integer :: ncid, rcode, numrec, nvars, ngatts, ndims, vid
      !
!     for reading netcdf files

      integer :: Dimidfortime, time_size
      !
!     Time is the main dimension for ver 200 netcdf files and can be as
!     large as 1440.  We need to know this dimension to size our data 
!     arrays for a file

      character (Len=31) :: TempName
      !
!     TempName will hold names of netcdf variables, dims, and attributs

!!!!!!!!CHANGES TO LAMM CODE BY OLAFSON!!!!!!
	character (Len=200) :: InputListFileName, ErrFileName
	character (len=200) :: command
	integer, parameter :: err_file = 69
	integer :: err_flag
!!!!!!!!END CHANGES!!!!!!!!!!!!!!!!!!!!!!!!!!

      real :: SavedHeights(NumParams)
      !
      real :: Heights(NumParams)
      !
!     Here we store the height of various instruments when it is available
!     or -9999.0 when it is not

      integer :: SavedConversUnits(NumParams)
      !
      integer :: Conv(NumParams)
      !
!     This is new for version 11. And is extra info Barrett now wants.

      real :: HNApply
      !
!     This variable only exists so as to have something to
!     pass to a required parameter of a subr where it really
!     does not apply in this case.  We throw away the value returned
!     in here.  The Converse units always applies so no similar
!     variable for it.


      logical :: FirstHeights
      !
!     In version 11, we use this as both first heights and first convers_units.
!     It is to say that this is the first time we have gotten and heights
!     or conversion units.

      character*20 :: ShipName

      FirstHeights = .true.

      call getarg(1, InputListFileName)
      !
!     This is our cruise, a list of many daily netcdf files that came
!     froma a particular ship for one cruise.

      open(20, file=InputListFileName)
      count = 1

!!!!!!!!CHANGES TO LAMM CODE BY OLAFSON!!!!!!
	write(*,*) 'starting step 1 of 3...'

	err_flag = 0

	ErrFileName=InputListFileName
	ErrFileName(LEN_TRIM(ErrFileName)-3:LEN_TRIM(ErrFileName)+4)='IMMA.err'
	open(err_file, file=TRIM(ErrFileName), status='unknown')

	do
	   read(20,'(A)', end= 2020)FileNames(count) 
	   count = count + 1
	   if (count .eq. MMaxFiles) then
	     err_flag = 1
	     write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
	     write(*,*)'ERROR: NUMBER OF INPUT FILES GREATER THAN ',MMaxFiles
	     write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
	     write(*,*)
	     write(err_file,*)'ERROR: NUMBER OF INPUT FILES GREATER THAN ',MMaxFiles
	     stop
	   endif
	enddo

 2020 count = count - 1
      close(20)

      open(OutputFile, &
      file=TRIM(InputListFileName)//'.DataFor.int',action='write')

      open(HInfo, &
      file=TRIM(InputListFileName)//'.HeightsFor.int',action='write')
      
      open(CInfo, &
      file=TRIM(InputListFileName)//'.ConvUsFor.int',action='write')
!!!!!!!!END CHANGES!!!!!!!!!!!!!!!!!!!!!!!!!!

!     main loop of program where we go through each netcdf file in our list
!     and tack on the contents of each file's data onto Outputfile that we
!     want to keep for later averaging

      BigLoop: do j = 1, count

!     if (DebugOn) write(*,*) ' calling ncopn for ',FileNames(j)
       write(*,*)
       write(*,*) ' calling ncopn for ',TRIM(FileNames(j))
!       !
!     maybe do write even when DegugTrace is not on at times as well 


!     if (DebugOn) write(*,*) ' calling ncpopt'

      call NCPOPT(NCVERBOS)      ! allows rcode to be checked
      !
!     Allow nc errors to not be fatal (we inspect rcode anyway)

      ncid = ncopn(FileNames(j), ncnowrit, rcode)
      !
!     rcode is like C system calls, it is 0 when successful
      !
      if (rcode .ne. 0) then
	err_flag = 1
	write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!'
        write(*,*)'ERROR: COULD NOT OPEN FILE', FileNames(j)
	write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!'
	write(err_file,*)'ERROR: COULD NOT OPEN FILE', FileNames(j)
        stop
      endif

      if (DebugOn) write(*,*) ' ncopt ncid ',ncid,' for ',FileNames(j)

      Dimidfortime = ncdid(ncid, 'time', rcode)

      if (rcode .ne. 0) then
        err_flag = 1
	write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!'
        write(*,*)'ERROR: COULD NOT GET LENGTH OF TIME DIMENSION'
	write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!'
	write(err_file,*)'ERROR: COULD NOT GET LENGTH OF TIME DIMENSION'
        stop
      endif

      if (j .eq. 1) then     ! first time so get ship ID
       ShipName='                    '
       call NCAGTC(ncid, NCGLOBAL,'ID',ShipName,20,rcode)
        !
       if (rcode .ne. 0) then
	err_flag = 1
	write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!'
        write(*,*)'ERROR: PROBLEM WITH SHIP ID', ShipName
	write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!'
	write(err_file,*)'ERROR: PROBLEM WITH SHIP ID', ShipName
        stop
       endif

       write(Outputfile,*)"'",TRIM(ShipName),"'"
      endif

      call ncdinq(ncid,Dimidfortime,TempName,time_size,rcode)
       !
      if (rcode .ne. 0) then
          print*,'EE error rcode in getting time_size'
          stop
      endif

      numrec = time_size

      if (DebugOn) write(*,*) time_size, ' is the size of time '

! I hate to make the above call to ncdinq and allocate these arrays here. 
! This should be done in the subroutine
! that reads these variables in so that these netcdf technicalities
! are transparent to the user but fortran 90 on SGI does not allow
! a passed parameter to be allocated,  so I have to make the above
! call and do it here for each of the above variables.
! Apparantly, you must allocate an array in the same program unit
! it is declared in and can't be passed to a subroutine to be allocated
! there.  FORTRAN 95 and some FORTEAN 90 compilers allow this.
       !
      allocate (time (numrec))
      allocate (timeflags (numrec))

      allocate (latitude (numrec))
      allocate (latitudeflags (numrec))

      allocate (latitude2 (numrec))
      allocate (latitude2flags (numrec))

      allocate (longitude (numrec))
      allocate (longitudeflags (numrec))

      allocate (longitude2 (numrec))
      allocate (longitude2flags (numrec))

      allocate (PL_HD (numrec))
      allocate (PL_HDflags (numrec))

      allocate (PL_HD2 (numrec))
      allocate (PL_HD2flags (numrec))

      allocate (PL_CRS (numrec))
      allocate (PL_CRSflags (numrec))

      allocate (PL_CRS2 (numrec))
      allocate (PL_CRS2flags (numrec))

      allocate (PL_CRS3 (numrec))
      allocate (PL_CRS3flags (numrec))

      allocate (PL_SPD (numrec))
      allocate (PL_SPDflags (numrec))

      allocate (PL_SPD2 (numrec))
      allocate (PL_SPD2flags (numrec))

      allocate (PL_SPD3 (numrec))
      allocate (PL_SPD3flags (numrec))
      
      allocate (PL_WDIR (numrec))
      allocate (PL_WDIRflags (numrec))

      allocate (PL_WSPD (numrec))
      allocate (PL_WSPDflags (numrec))

      allocate (PL_WDIR2 (numrec))
      allocate (PL_WDIR2flags (numrec))

      allocate (PL_WSPD2 (numrec))
      allocate (PL_WSPD2flags (numrec))

      allocate (PL_WDIR3 (numrec))
      allocate (PL_WDIR3flags (numrec))

      allocate (PL_WSPD3 (numrec))
      allocate (PL_WSPD3flags (numrec))

      allocate (DIR (numrec))
      allocate (DIRflags (numrec))

      allocate (SPD (numrec))
      allocate (SPDflags (numrec))

      allocate (DIR2 (numrec))
      allocate (DIR2flags (numrec))

      allocate (SPD2 (numrec))
      allocate (SPD2flags (numrec))

      allocate (DIR3 (numrec))
      allocate (DIR3flags (numrec))

      allocate (SPD3 (numrec))
      allocate (SPD3flags (numrec))

      allocate (P (numrec))
      allocate (Pflags (numrec))

      allocate (temperature (numrec))
      allocate (temperatureflags (numrec)) 

      allocate (temperature2 (numrec))
      allocate (temperature2flags (numrec))

      allocate (temperature3 (numrec))
      allocate (temperature3flags (numrec))

      allocate (T (numrec))
      allocate (Tflags (numrec)) 

      allocate (T2 (numrec))
      allocate (T2flags (numrec))

      allocate (TW (numrec))
      allocate (TWflags (numrec))

      allocate (TW2 (numrec))
      allocate (TW2flags (numrec))

      allocate (TD (numrec))
      allocate (TDflags (numrec))

      allocate (TD2 (numrec))
      allocate (TD2flags (numrec))

      allocate (RH (numrec))
      allocate (RHflags (numrec))

      allocate (RH2 (numrec))
      allocate (RH2flags (numrec))

      allocate (PRECIP (numrec))
      allocate (PRECIPflags (numrec))

      allocate (RAD (numrec))
      allocate (RADflags (numrec))

      allocate (RAD2 (numrec))
      allocate (RAD2flags (numrec))

      allocate (RAD3 (numrec))
      allocate (RAD3flags (numrec))

      allocate (Q (numrec))
      allocate (Qflags (numrec))

      allocate (Q2 (numrec))
      allocate (Q2flags (numrec))

      allocate (RRATE (numrec))
      allocate (RRATEflags (numrec))

      allocate (NONE (numrec))
      allocate (NONEflags (numrec))



!     we call this canned routine to get the times.  The routine
!     takes into account how ver200 files are set up.  
!     It returns the status in rcode
!     so as to mimick netcdf routines.
!     Notice the array given it is allocated.  
!     Say DebugTrace = 1 at end to get debug trace
!
!     The code for this  'canned' routine is at the end of this listing


      call getver200intvals(ncid,"time        ", time, &
                            timeflags, rcode,DebugTrace=1, StopOnProb=1)
                                 !
!     StopOnProb can be set to 1 when you want it to stop if problem occurs
!     rather than checking rcode to see if it worked.  Both DebugTrace and
!     StopOnProb are optional parameters.  It does no trace and does
!     StopOnProb by default

!     I don't need the date values since I derive that from time

!     now for the others we want which are real 
!     so a differ subr used.    


!     !!!! NOTE   !!!! NOTE !!!!! NOTE
        !
!     blank fill end of param name so that it is at least 12 char long 
!     Things do not work otherwise !!!!!!!!!!!!!  Like "latitude    " rather
!     that "latitude".

      call getver200fltvals (ncid,"latitude    ",  latitude,  latitudeflags,&
                                    HNApply, Conv(clatitude),rcode,DebugTrace=1)
                                     !
!     I never really needed to say StopOnProb since I want it to and it
!     is that way by default.  Did it one time to display technique. Some values
!     can be missing and it is not taken as a big enough problem to stop.
!
!     HNApply gets the height value.  A lot of times, we don't really want it.
!     In those cases we pass HNApply which then we don't use.  It acts as
!     a placeholder when we don't really want it.  Other times we send a
!     specially created storage container when we do what it


      call getver200fltvals (ncid,"longitude   ",  longitude, longitudeflags,&
                                    HNApply, Conv(clongitude),rcode,DebugTrace=1)

      call getver200fltvals (ncid,"latitude2   ",  latitude2, latitude2flags,&
                                    HNApply, Conv(clatitude2),rcode,DebugTrace=1)
      call FMissing ( "latitude2   ",latitude2, latitude2flags,   rcode)
!     !
!     FMissing gets called when we have a variable that could possibly be missing
!     from the netcdf and that is not necessarily cause for alarm.  Lat Lon are 
!     examples of variables that need to be there.  When called the function checks
!     to see if there (by looking at rcode) and if not puts -19999.9s and a 'K' in the
!     flags. 


      call getver200fltvals (ncid,"longitude2  ",  longitude2,longitude2flags,&
                                    HNApply, Conv(clongitude2),rcode,DebugTrace=1)
      call FMissing ( "longitude2  ",longitude2,longitude2flags, rcode)


      call getver200fltvals (ncid,"PL_HD       ",  PL_HD, PL_HDflags,&
                                     HNApply,Conv(cPL_HD), rcode,DebugTrace=1) 

      call FMissing ( "PL_HD       ",  PL_HD, PL_HDflags, rcode) 

      call getver200fltvals (ncid,"PL_HD2      ",  PL_HD2, PL_HD2flags,&
                                     HNApply,Conv(cPL_HD2),rcode,DebugTrace=1)

      call FMissing ( "PL_HD2      ",  PL_HD2, PL_HD2flags ,rcode)


      call getver200fltvals (ncid,"PL_CRS      ",  PL_CRS, PL_CRSflags,&
                                    HNApply, Conv(cPL_CRS),rcode,DebugTrace=1) 

      call FMissing ( "PL_CRS      ",  PL_CRS, PL_CRSflags, rcode)


      call getver200fltvals (ncid,"PL_CRS2     ",  PL_CRS2, PL_CRS2flags,&
                                    HNApply, Conv(cPL_CRS2),rcode,DebugTrace=1)

      call FMissing ( "PL_CRS2     ",  PL_CRS2, PL_CRS2flags, rcode)


      call getver200fltvals (ncid,"PL_CRS3     ",  PL_CRS3, PL_CRS3flags,&
                                     HNApply,Conv(cPL_CRS3),rcode,DebugTrace=1)

      call FMissing ( "PL_CRS3     ",  PL_CRS3, PL_CRS3flags, rcode)


      call getver200fltvals (ncid,"PL_SPD      ",  PL_SPD,  PL_SPDflags,&
                                     HNApply,Conv(cPL_SPD), rcode,DebugTrace=1)

      call FMissing ( "PL_SPD      ",  PL_SPD,  PL_SPDflags, rcode)


      call getver200fltvals (ncid,"PL_SPD2     ",  PL_SPD2, PL_SPD2flags,&
                                     HNApply,Conv(cPL_SPD2),rcode,DebugTrace=1)

      call FMissing ( "PL_SPD2     ",  PL_SPD2, PL_SPD2flags, rcode)


      call getver200fltvals (ncid,"PL_SPD3     ",  PL_SPD3, PL_SPD3flags,&
                                     HNApply,Conv(cPL_SPD3),rcode,DebugTrace=1)

      call FMissing ( "PL_SPD3     ",  PL_SPD3, PL_SPD3flags, rcode)


      call getver200fltvals (ncid,"PL_WDIR     ",  PL_WDIR, PL_WDIRflags,&
                          Heights(cPL_WDIR), Conv(cPL_WDIR), rcode,DebugTrace=1)

      call FMissing ( "PL_WDIR     ",  PL_WDIR, PL_WDIRflags,rcode) 


      call getver200fltvals (ncid,"PL_WSPD     ",  PL_WSPD, PL_WSPDflags,&
                          Heights(cPL_WSPD), Conv(cPL_WSPD),rcode,DebugTrace=1)

      call FMissing ( "PL_WSPD     ",  PL_WSPD, PL_WSPDflags,rcode)
 

      call getver200fltvals (ncid,"PL_WDIR2    ",  PL_WDIR2, PL_WDIR2flags,&
                          Heights(cPL_WDIR2),Conv(cPL_WDIR2),rcode,DebugTrace=1)

      call FMissing ( "PL_WDIR2    ",  PL_WDIR2, PL_WDIR2flags,rcode)


      call getver200fltvals (ncid,"PL_WSPD2    ",  PL_WSPD2, PL_WSPD2flags,&
                          Heights(cPL_WSPD2),Conv(cPL_WSPD2),rcode,DebugTrace=1)

      call FMissing ( "PL_WSPD2    ",  PL_WSPD2, PL_WSPD2flags,rcode)


      call getver200fltvals (ncid,"PL_WDIR3    ",  PL_WDIR3, PL_WDIR3flags,&
                          Heights(cPL_WDIR3),Conv(cPL_WDIR3),rcode,DebugTrace=1)

      call FMissing ( "PL_WDIR3    ",  PL_WDIR3, PL_WDIR3flags,rcode)


      call getver200fltvals (ncid,"PL_WSPD3    ",  PL_WSPD3, PL_WSPD3flags,&
                          Heights(cPL_WSPD3),Conv(cPL_WSPD3),rcode,DebugTrace=1)

      call FMissing ( "PL_WSPD3    ",  PL_WSPD3, PL_WSPD3flags,rcode)


      call getver200fltvals (ncid,"DIR         ",  DIR,      DIRflags,&
                          heights(cDIR),     Conv(cDIR),rcode,DebugTrace=1)
 
      call FMissing ( "DIR         ",  DIR,      DIRflags,   rcode)



      call getver200fltvals (ncid,"SPD         ",  SPD,      SPDflags,&
                          Heights(cSPD),     Conv(cSPD),rcode,DebugTrace=1)

      call FMissing ( "SPD         ",  SPD,      SPDflags,rcode)

      call getver200fltvals (ncid,"DIR2        ",  DIR2,     DIR2flags,&
                          Heights(cDIR2),    Conv(cDIR2),rcode,DebugTrace=1)

      call FMissing ( "DIR2        ",  DIR2,     DIR2flags,rcode )


      call getver200fltvals (ncid,"SPD2        ",  SPD2,     SPD2flags,&
                          Heights(cSPD2),    Conv(cSPD2),rcode,DebugTrace=1)

      call FMissing ( "SPD2        ",  SPD2,     SPD2flags,rcode )



      call getver200fltvals (ncid,"DIR3        ",  DIR3,     DIR3flags,&
                          Heights(cDIR3),    Conv(cDIR3),rcode,DebugTrace=1)

      call FMissing ( "DIR3        ",  DIR3,     DIR3flags,rcode )



      call getver200fltvals (ncid,"SPD3        ",  SPD3,     SPD3flags,&
                          Heights(cSPD3),    Conv(cSPD3), rcode,DebugTrace=1)

      call FMissing ( "SPD3        ",  SPD3,     SPD3flags,rcode )




      call getver200fltvals (ncid,"P           ",  P,        Pflags,&
                          Heights(cP),       Conv(cP),rcode,DebugTrace=1)

      call FMissing ( "P           ",  P,        Pflags,rcode )



      call getver200fltvals (ncid,"temperature ",        temperature, temperatureflags,&
                          Heights(ctemperature),   Conv(ctemperature), rcode, DebugTrace=1)

      call FMissing ( "temperature ",  temperature, temperatureflags,rcode )



      call getver200fltvals (ncid,"temperature2",       temperature2, temperature2flags,&
                          Heights(ctemperature2), Conv(ctemperature2),rcode,DebugTrace=1)

      call FMissing ( "temperature2",  temperature2, temperature2flags,rcode  )



      call getver200fltvals (ncid,"temperature3",      temperature3,temperature3flags,&
                          Heights(ctemperature3),Conv(ctemperature3),rcode,DebugTrace=1)


      call FMissing ( "temperature3",  temperature3, temperature3flags,rcode  )


      call getver200fltvals (ncid,"T           ",  T,            Tflags,&
                          Heights(cT),       Conv(cT),rcode,DebugTrace=1)

      call FMissing ( "T           ",  T,            Tflags,rcode   )


      call getver200fltvals (ncid,"T2          ",  T2,           T2flags,&
                          Heights(cT2),      Conv(cT2),rcode,DebugTrace=1)

      call FMissing ( "T2          ",  T2,           T2flags,rcode  )



      call getver200fltvals (ncid,"TW          ",  TW,           TWflags,&
                          Heights(cTW),      Conv(cTW),rcode,DebugTrace=1)

      call FMissing ( "TW          ",  TW,           TWflags,rcode  )


      call getver200fltvals (ncid,"TW2         ",  TW2,          TW2flags,&
                          Heights(cTW2),     Conv(cTW2),rcode,DebugTrace=1)


      call FMissing ( "TW2         ",  TW2,          TW2flags,rcode  )



      call getver200fltvals (ncid,"TD          ",    TD,           TDflags,&
                          Heights(cTD),        Conv(cTD),rcode,DebugTrace=1)

      call FMissing ( "TD          ",  TD,           TDflags,rcode  )



      call getver200fltvals (ncid,"TD2         ",  TD2,          TD2flags,&
                          Heights(cTD2),     Conv(cTD2),rcode,DebugTrace=1)

      call FMissing ( "TD2         ",  TD2,          TD2flags,rcode  )



      call getver200fltvals (ncid,"RH          ",  RH,           RHflags,&
                          Heights(cRH),      Conv(cRH),rcode,DebugTrace=1)


      call FMissing ( "RH          ",  RH,           RHflags,rcode  )


      call getver200fltvals (ncid,"RH2         ",  RH2,          RH2flags,&
                          Heights(cRH2),     Conv(cRH2),rcode,DebugTrace=1)

      call FMissing ( "RH2         ",  RH2,          RH2flags,rcode  )




      call getver200fltvals (ncid,"PRECIP      ",  PRECIP,       PRECIPflags,&
                          Heights(cPRECIP),  Conv(cPRECIP),rcode,DebugTrace=1)

      call FMissing ( "PRECIP      ",  PRECIP,       PRECIPflags,rcode  )

 

      call getver200fltvals (ncid,"RAD         ",  RAD,          RADflags,&
                          Heights(cRAD),     Conv(cRAD),rcode,DebugTrace=1) 

      call FMissing ( "RAD         ",  RAD,          RADflags,rcode  )



      call getver200fltvals (ncid,"RAD2        ",  RAD2,         RAD2flags,&
                          Heights(cRAD2),    Conv(cRAD2),rcode,DebugTrace=1)

      call FMissing ( "RAD2        ",  RAD2,         RAD2flags,rcode  )



      call getver200fltvals (ncid,"RAD3        ",  RAD3,         RAD3flags,&
                          Heights(cRAD3),    Conv(cRAD3),rcode,DebugTrace=1)

      call FMissing ( "RAD3        ",  RAD3,         RAD3flags,rcode  )


      call getver200fltvals (ncid,"Q           ",  Q, Qflags,&
                          Heights(cQ),       Conv(cQ),rcode,DebugTrace=1) 

      call FMissing ( "Q           ",  Q, Qflags,rcode  )

      call getver200fltvals (ncid,"Q2          ",  Q2, Q2flags,&
                          Heights(cQ2),      Conv(cQ2),rcode, DebugTrace=1)


      call FMissing ( "Q2          ",  Q2, Q2flags,rcode  )



      call getver200fltvals (ncid,"RRATE       ",  RRATE, RRATEflags,&
                          Heights(cRRATE),   Conv(cRRATE),rcode,DebugTrace=1)

      call FMissing ( "RRATE       ",  RRATE, RRATEflags,rcode  )

 

      call getver200fltvals (ncid,"NONE        ",  NONE,  NONEflags,&
                          Heights(cNONE),    Conv(cNONE),rcode,DebugTrace=1) 

      call FMissing ( "NONE        ",  NONE,  NONEflags,rcode  )

                              

      call ncclos(ncid, rcode)

      if (rcode .ne. 0) then
       err_flag = 1
       write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!'
       write(*,*)'ERROR: COULD NOT CLOSE FILE'
       write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!'
       write(err_file,*)'ERROR: COULD NOT CLOSE FILE'
       stop
      endif

      if (DebugOn) then
        print*,'Closing netcdf file doing qa qs stuff'
      endif

      do i=1, numrec
!      write(*,*) time(i), ' the time '
       call invtime(time(i), yr, mo, dy, hr, min)
       byr =  yr
       bmo =  mo
       bdy =  dy
       bhr =  hr
       bmin = min

!CHANGE  this could CHANGE might want different interval later and such
! Note: at a much later date -- it doesn't look like it will change This
! is it!  !
          !
       if ((min .ge. 50) .or. (min .eq. 0)) then
         if (min .ge. 50) then
!          write(*,*) time(i), ' the time 2'
           call invtime(time(i)+15, yr, mo, dy,hr, min)
           ! we want the hour to go with the 00 reading of next hour
         endif
         zerotime = convtime(yr,mo,dy,hr,0)
         ! we just give it the time of the 00 reading
         write(OutputFile,*)zerotime, ' ',yr ,' ', mo,' ', dy,' ', hr

!        write(OutputFile,*)time(i) , ' ',byr,' ',bmo,' ',bdy,' ',bhr,' ',bmin, i, 'add line '
!          !
!   this includes the origial time for debugging but not wanted in general


         if (FirstHeights ) then
          do iji2 = 1, NumParams
           SavedHeights(iji2) = Heights(iji2) 
           SavedConversUnits(iji2) = Conv(iji2)         
          enddo
          write(HInfo,*) SavedHeights
          !
!   the heights, conv should not change 
!   so write them out once and forget about it.
          !          
          write(CInfo,*) SavedConversUnits
          FirstHeights = .false.
         else

          do iji2 = 1, NumParams

!!!!!!!!CHANGES TO LAMM CODE BY OLAFSON!!!!!!
           if (SavedHeights(iji2) .ne. Heights(iji2) ) then
	     err_flag = 1

write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
	     write(*,*)'ERROR: INPUT HEIGHT DOES NOT MATCH CORRESPONDING LIBRARY VALUE'
	     write(*,*)'       AT ', yr, mo, dy, hr
write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
	     write(*,*)
	     write(err_file, *)'ERROR: INPUT HEIGHT DOES NOT MATCH CORRESPONDING LIBRARY VALUE AT ', yr, mo, dy, hr
            stop
           endif
             !
           if (SavedConversUnits(iji2) .ne. Conv(iji2) ) then
	     err_flag = 1

write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
	     write(*,*)'ERROR: INPUT CONVERSION UNIT DOES NOT MATCH CORRESPONDING LIBRARY VALUE'
	     write(*,*)'       AT ', yr, mo, dy, hr
write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
	     write(*,*)
	     write(err_file, *)'ERROR: INPUT CONVERSION UNIT DOES NOT MATCH CORRESPONDING LIBRARY VALUE AT ', yr, mo, dy, hr
            stop
           endif
            
!!!!!!!!END CHANGES!!!!!!!!!!!!!!!!!!!!!!!!!!
          
          enddo

         endif ! end of the else part

         write(OutputFile,'(a)') timeflags(i)

         write(OutputFile,*)  "'latitude'"
         write(OutputFile,*)   latitude(i)
         write(OutputFile,'(a)') latitudeflags(i)

         write(OutputFile,*)  "'longitude'"
         write(OutputFile,*)   longitude(i)
         write(OutputFile,'(a)') longitudeflags(i)

         write(OutputFile,*)        "'PL_HD'"
         write(OutputFile,*)          PL_HD(i)
         write(OutputFile,'(a)')      PL_HDflags(i)

         write(OutputFile,*)        "'PL_HD2'"
         write(OutputFile,*)          PL_HD2(i)
         write(OutputFile,'(a)')      PL_HD2flags(i)

         write(OutputFile,*)        "'PL_CRS'"
         write(OutputFile,*)          PL_CRS(i)
         write(OutputFile,'(a)')      PL_CRSflags(i)

         write(OutputFile,*)        "'PL_CRS2'"
         write(OutputFile,*)          PL_CRS2(i)
         write(OutputFile,'(a)')      PL_CRS2flags(i)

         write(OutputFile,*)        "'PL_CRS3'"
         write(OutputFile,*)          PL_CRS3(i)
         write(OutputFile,'(a)')      PL_CRS3flags(i)

         write(OutputFile,*)        "'PL_SPD'"
         write(OutputFile,*)          PL_SPD(i)
         write(OutputFile,'(a)')      PL_SPDflags(i)

         write(OutputFile,*)        "'PL_SPD2'"
         write(OutputFile,*)          PL_SPD2(i)
         write(OutputFile,'(a)')      PL_SPD2flags(i)

         write(OutputFile,*)        "'PL_SPD3'"
         write(OutputFile,*)          PL_SPD3(i)
         write(OutputFile,'(a)')      PL_SPD3flags(i)

         write(OutputFile,*)         "'PL_WDIR'"
         write(OutputFile,*)           PL_WDIR(i)
         write(OutputFile,'(a)')       PL_WDIRflags(i)

         write(OutputFile,*)         "'PL_WSPD'"
         write(OutputFile,*)           PL_WSPD(i)
         write(OutputFile,'(a)')       PL_WSPDflags(i)

         write(OutputFile,*)         "'PL_WDIR2'"
         write(OutputFile,*)           PL_WDIR2(i)
         write(OutputFile,'(a)')       PL_WDIR2flags(i)

         write(OutputFile,*)         "'PL_WSPD2'"
         write(OutputFile,*)           PL_WSPD2(i)
         write(OutputFile,'(a)')       PL_WSPD2flags(i)

         write(OutputFile,*)         "'PL_WDIR3'"
         write(OutputFile,*)           PL_WDIR3(i)
         write(OutputFile,'(a)')       PL_WDIR3flags(i)

         write(OutputFile,*)         "'PL_WSPD3'"
         write(OutputFile,*)           PL_WSPD3(i)
         write(OutputFile,'(a)')       PL_WSPD3flags(i)

         write(OutputFile,*)         "'DIR'"
         write(OutputFile,*)           DIR(i)
         write(OutputFile,'(a)')       DIRflags(i)


         write(OutputFile,*)         "'SPD'"
         write(OutputFile,*)           SPD(i)
         write(OutputFile,'(a)')       SPDflags(i)


         write(OutputFile,*)         "'DIR2'"
         write(OutputFile,*)           DIR2(i)
         write(OutputFile,'(a)')       DIR2flags(i)

         write(OutputFile,*)         "'SPD2'"
         write(OutputFile,*)           SPD2(i)
         write(OutputFile,'(a)')       SPD2flags(i)


         write(OutputFile,*)         "'DIR3'"
         write(OutputFile,*)           DIR3(i)
         write(OutputFile,'(a)')       DIR3flags(i)


         write(OutputFile,*)         "'SPD3'"
         write(OutputFile,*)           SPD3(i)
         write(OutputFile,'(a)')       SPD3flags(i)


         write(OutputFile,*)         "'P'"
         write(OutputFile,*)           P(i)
         write(OutputFile,'(a)')       Pflags(i)

         write(OutputFile,*)         "'temperature'"
         write(OutputFile,*)           temperature(i)
         write(OutputFile,'(a)')       temperatureflags(i)

         write(OutputFile,*)         "'temperature2'"
         write(OutputFile,*)           temperature2(i)
         write(OutputFile,'(a)')       temperature2flags(i)

         write(OutputFile,*)         "'temperature3'"
         write(OutputFile,*)           temperature3(i)
         write(OutputFile,'(a)')       temperature3flags(i)


         write(OutputFile,*)         "'T'"
         write(OutputFile,*)           T(i)
         write(OutputFile,'(a)')       Tflags(i)

         write(OutputFile,*)         "'T2'"
         write(OutputFile,*)           T2(i)
         write(OutputFile,'(a)')       T2flags(i)


         write(OutputFile,*)         "'TW'"
         write(OutputFile,*)           TW(i)
         write(OutputFile,'(a)')       TWflags(i)

         write(OutputFile,*)         "'TW2'"
         write(OutputFile,*)           TW2(i)
         write(OutputFile,'(a)')       TW2flags(i)

         write(OutputFile,*)         "'TD'"
         write(OutputFile,*)           TD(i)
         write(OutputFile,'(a)')       TDflags(i)


         write(OutputFile,*)         "'TD2'"
         write(OutputFile,*)           TD2(i)
         write(OutputFile,'(a)')       TD2flags(i)

         write(OutputFile,*)         "'RH'"
         write(OutputFile,*)           RH(i)
         write(OutputFile,'(a)')       RHflags(i)


         write(OutputFile,*)         "'RH2'"
         write(OutputFile,*)           RH2(i)
         write(OutputFile,'(a)')       RH2flags(i)


         write(OutputFile,*)         "'PRECIP'"
         write(OutputFile,*)           PRECIP(i)
         write(OutputFile,'(a)')       PRECIPflags(i)


         write(OutputFile,*)         "'RAD'"
         write(OutputFile,*)           RAD(i)
         write(OutputFile,'(a)')       RADflags(i)

         write(OutputFile,*)         "'RAD2'"
         write(OutputFile,*)           RAD2(i)
         write(OutputFile,'(a)')       RAD2flags(i)

         write(OutputFile,*)         "'RAD3'"
         write(OutputFile,*)           RAD3(i)
         write(OutputFile,'(a)')       RAD3flags(i)

         write(OutputFile,*)         "'Q'"
         write(OutputFile,*)           Q(i)
         write(OutputFile,'(a)')       Qflags(i)

         write(OutputFile,*)         "'Q2'"
         write(OutputFile,*)           Q2(i)
         write(OutputFile,'(a)')       Q2flags(i)

         write(OutputFile,*)         "'RRATE'"
         write(OutputFile,*)           RRATE(i)
         write(OutputFile,'(a)')       RRATEflags(i)

         write(OutputFile,*)         "'latitude2'"
         write(OutputFile,*)           latitude2(i)
         write(OutputFile,'(a)')       latitude2flags(i)

         write(OutputFile,*)         "'longitude2'"
         write(OutputFile,*)           longitude2(i)
         write(OutputFile,'(a)')       longitude2flags(i)

         write(OutputFile,*)         "'NONE'"
         write(OutputFile,*)           NONE(i)
         write(OutputFile,'(a)')       NONEflags(i)
        endif
       enddo

!        write(*,*) ' done writes'

        if (allocated (time)) then
          deallocate(time)
          deallocate(timeflags)
        endif

        if (allocated (latitude)) then
          deallocate(latitude)
          deallocate(latitudeflags)
        endif
        if (allocated (longitude)) then
          deallocate(longitude)
          deallocate(longitudeflags)
        endif
        if (allocated (PL_HD)) then
          deallocate(PL_HD)
          deallocate(PL_HDflags)
        endif
        if (allocated (PL_HD2)) then
          deallocate(PL_HD2)
          deallocate(PL_HD2flags)
        endif
        if (allocated (PL_CRS)) then
          deallocate(PL_CRS)
          deallocate(PL_CRSflags)
        endif
        if (allocated (PL_CRS2)) then
          deallocate(PL_CRS2)
          deallocate(PL_CRS2flags)
        endif
        if (allocated (PL_CRS3)) then
          deallocate(PL_CRS3)
          deallocate(PL_CRS3flags)
        endif
        if (allocated (PL_SPD)) then
          deallocate(PL_SPD)
          deallocate(PL_SPDflags)
        endif
        if (allocated (PL_SPD2)) then
          deallocate(PL_SPD2)
          deallocate(PL_SPD2flags)
        endif
        if (allocated (PL_SPD3)) then
          deallocate(PL_SPD3)
          deallocate(PL_SPD3flags)
        endif
        if (allocated (PL_WDIR)) then
          deallocate(PL_WDIR)
          deallocate(PL_WDIRflags)
        endif
        if (allocated (PL_WSPD)) then
          deallocate(PL_WSPD)
          deallocate(PL_WSPDflags)
        endif
        if (allocated (PL_WDIR2)) then
          deallocate(PL_WDIR2)
          deallocate(PL_WDIR2flags)
        endif
        if (allocated (PL_WSPD2)) then
          deallocate(PL_WSPD2)
          deallocate(PL_WSPD2flags)
        endif
        if (allocated (PL_WDIR3)) then
          deallocate(PL_WDIR3)
          deallocate(PL_WDIR3flags)
        endif
        if (allocated (PL_WSPD3)) then
          deallocate(PL_WSPD3)
          deallocate(PL_WSPD3flags)
        endif
        if (allocated (DIR)) then
          deallocate(DIR)
          deallocate(DIRflags)
        endif
        if (allocated (SPD)) then
          deallocate(SPD)
          deallocate(SPDflags)
        endif
        if (allocated (DIR2)) then
          deallocate(DIR2)
          deallocate(DIR2flags)
        endif
        if (allocated (SPD2)) then
          deallocate(SPD2)
          deallocate(SPD2flags)
        endif
        if (allocated (DIR3)) then
          deallocate(DIR3)
          deallocate(DIR3flags)
        endif
        if (allocated (SPD3)) then
         deallocate(SPD3)
         deallocate(SPD3flags)
        endif
         if (allocated (P)) then
           deallocate(P)
           deallocate(Pflags)
         endif
        if (allocated (temperature)) then
          deallocate(temperature)
          deallocate(temperatureflags)
        endif
        if (allocated (temperature2)) then
          deallocate(temperature2)
          deallocate(temperature2flags)
        endif
         if (allocated (temperature3)) then
            deallocate(temperature3)
            deallocate(temperature3flags)
         endif
        if (allocated (T)) then
         deallocate(T)
         deallocate(Tflags)
        endif
        if (allocated (T2)) then
         deallocate(T2)
         deallocate(T2flags)
        endif
        if (allocated (TW)) then
         deallocate(TW)
         deallocate(TWflags)
        endif
        if (allocated (TW2)) then
          deallocate(TW2)
          deallocate(TW2flags)
        endif
        if (allocated (TD)) then
          deallocate(TD)
          deallocate(TDflags)
        endif
        if (allocated (TD2)) then
          deallocate(TD2)
          deallocate(TD2flags)
        endif
        if (allocated (RH)) then
          deallocate(RH)
          deallocate(RHflags)
        endif
        if (allocated (RH2)) then
          deallocate(RH2)
          deallocate(RH2flags)
        endif
        if (allocated (PRECIP)) then
          deallocate(PRECIP)
          deallocate(PRECIPflags)
        endif
        if (allocated (RAD)) then
          deallocate(RAD)
          deallocate(RADflags)
        endif
        if (allocated (RAD2)) then
          deallocate(RAD2)
          deallocate(RAD2flags)
        endif
        if (allocated (RAD3)) then
          deallocate(RAD3)
          deallocate(RAD3flags)
        endif
        if (allocated (Q)) then
          deallocate(Q)
          deallocate(Qflags)
        endif
        if (allocated (Q2)) then
          deallocate(Q2)
          deallocate(Q2flags)
        endif
        if (allocated (RRATE)) then
          deallocate(RRATE)
          deallocate(RRATEflags)
        endif
        if (allocated (latitude2)) then
          deallocate(latitude2)
          deallocate(latitude2flags)
        endif
        if (allocated (longitude2)) then
          deallocate(longitude2)
          deallocate(longitude2flags)
        endif


        if (allocated (NONE)) then
          deallocate(NONE)
          deallocate(NONEflags)
        endif
            
      enddo BigLoop

! one last write of sentinal values to show end of data
         write(OutputFile,*)-14000, ' ',-1,' ',-1,' ',-1,' ',-1

!!!!!!!!CHANGES TO LAMM CODE BY OLAFSON!!!!!!
	close(err_file)

	if (err_flag.eq.0) then
	   write(*,*)
	   write(*,*)'No errors in step 1'
	else
	   write(*,*)
	   write(*,*) 'ERROR FILE: ', TRIM(ErrFileName)
	end if

	print*,'step 1 of 3 complete'
!!!!!!!!END CHANGES!!!!!!!!!!!!!!!!!!!!!!!!!!


      stop


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


      CONTAINS

! NETCDF Version 200 General Read routines :::::::::::::::::::::::
!
!  !!! NOTE !!!!! NOTE !!!!! NOTE
!
!   I have changed these general routines some for the purpose at hand,
!   like take some attribute information.
!
!    To use these routines your main program should look somethin like:
!    
!    prog blablabla
!        .
!        .  your program code
!        .
!
!     CONTAINS
!       .
!       . other procedures to contain
!       .
! NETCDF Version 200 Read routines :::::::::::::::::::::::
!      subroutine getver200intvals ...
!       .
!       .
!       .
!      subroutine getver200fltvals
!       .
!       .
!       .
!
!      end subroutine getver200fltvals
! END NETCDF Version 200 Read routines ::::::::::::::::
!       .
!       .
!       .  other procedures to contain
!
!     end ! program blablabla
!
!    Using the contain statement allows type checking.  
!    If you make this code external then
!    I believe type checking is defeated (unless you make an interface
!    block or soemthing like that)
!
!    suppose you want to get latitude values.  In program blablabla one would
!    have code like:
!
!      USE netcdf_inc  ! need this include file
!       .
!       .
!       .
!      real, allocatable, dimension(:) :: latitude
!      character, allocatable, dimension(:) :: latitudeflags
!      integer:: ncid,Dimidfortime,rcode,time_xize
!      character (Len=31) :: TempName
!      . 
!      .
!      .
!      call NCPOPT(NCVERBOS) 
!      ncid = ncopn(FileName,ncnowrit,rcode)
!      Dimidfortime = ncdid(ncid, 'time', rcode)
!      dimension time is needed to size our arrays
!      call ncdinq(ncid,Dimidfortime,TempName,time_size,rcode)
!      allocate (latitude (time_size))
!      allocate (latitudeflags (time_size))
!                  
!      call getver200fltvals (ncid,"latitude   ", latitude, latitudeflags,&
!                             rcode,DebugTrace=1)
!
!      where DubugTrace is optional (off by default, 1 turns it on) and
!            StopOnProb is optional (on by default,  0 turns it off)
!
!       checking rcode for .ne. 0 on return would catch problems in case you
!       want go on even when read was unsuccessful.  The meaning of rcode
!       is in netcdf_inc.
!
!
!       Notice I blank fill "latitude     " to 12 chars or more.
!       This is needed. !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! NOTE NOTE NOTE NOTE NOTE In this file I make a small change to the usual getver200fltvals
! in that I add an extra hord parameter (height or depth) since Shawn wants that for several
! variables which I get from the attributes but this is deviating from the standard routines
! also converse units.

      subroutine getver200intvals(ncid, NameOfPar,  Arrayv, &
        Arrayvflags, rcode, DebugTrace, StopOnProb)
      implicit none

      integer, intent(in) :: ncid
      character (Len=12), intent(in) :: NameOfPar ! no par name should be bigger
      integer, intent(out), dimension(:)  :: Arrayv
      character, intent(out), dimension(:)  :: Arrayvflags
      integer, optional :: DebugTrace, StopOnProb
      integer :: rcode, vid, qcindex,iii
      integer :: recdim, ndims, nvars, ngatts ,Dimidfortime

      integer :: Dimidforf_string, f_string_size, tempint1, tempint2, i
      character (Len=31) :: TempName 

      character :: let

      integer, dimension(2) :: placeofflag
      logical DebugOn, StopOnProblem

      logical NameOfParFound

      DebugOn = .false.

      NameOfParFound = .false.
      StopOnProblem = .true.

!      if (present(DebugTrace)) then
!        if (DebugTrace .eq. 1) then
!         DebugOn = .true.
!        endif
!      endif

      if (DebugOn) then
       print*,' into getver200intvals '
      endif

      if (present(StopOnProb)) then
        if (StopOnProb .eq. 0) then
         StopOnProblem = .false.
        endif
      endif

!     if (DebugOn) then
!       print*,'Debugtr about to inquire about ', ncid,' time size '
!     endif

!     Inquire for info on nc file parameters:

      Dimidfortime = ncdid(ncid, 'time', rcode)

       if (rcode .ne. 0) then
          print*,'EE error rcode in getting time dim'
          if (StopOnProblem) then
            stop 
          else 
           return
          endif
       endif

!     if (DebugOn) then
!       print*,'Debugtr about to get time size '
!     endif

      call ncdinq(ncid,Dimidfortime,TempName,recdim,rcode)

!     if (DebugOn) then
!       print*,'time size is ',recdim
!     endif

      if ( rcode .NE. 0 ) then
           print*, 'EE Error in getting info on netcdf data file: ', rcode 
           print*, '   netcdf file has id ',ncid
          if (StopOnProblem) then
            stop 
          else 
           return
          endif
      endif

!      if (DebugOn) then
!        print*,'Debugtr About to do size Arrayvflags'
!      endif

      if (size(Arrayvflags) .ne. recdim) then
        print*,'EE Arrayvflags should have dimension ',recdim
          rcode = -200
          if (StopOnProblem) then
            stop 
          else 
           return
          endif
      endif

!      if (DebugOn) then
!        print*,'Debugtr About to do size Arrayv'
!      endif

      if (size(Arrayv) .ne. recdim) then
          print*,'EE Arrayv should have dimension ',recdim
          rcode = -200
          if (StopOnProblem) then
            stop 
          else 
           return
          endif
      endif       

!     in string comparisons FORTRAN blank fills the shorter string so this
!     should work, i.e.  'time' .eq. 'time          ' in FORTRAN 90

!      if (DebugOn) then
!       print*,'Debugtr in getver200intvals looking for_ ',NameOfPar 
!      endif

!--------------------------------------------------------------------------

      if (NameOfPar .eq. 'time') then
!       print*,'in there'
      if (DebugOn) then
       print*,'Debugtr found and in time block' 
      endif

      NameOfParFound = .true.

      if (DebugOn) then
       print*,'Debugtr getting vid for time' 
      endif

      vid=ncvid(ncid,'time',rcode)

      if (rcode .ne. 0) then
          print*,'EE error rcode in getting vid for time'
          if (StopOnProblem) then
            stop 
          else 
           return
          endif
      endif

!     if (DebugOn) then
!      print*,'Debugtr Getting Arrayv' 
!     endif

      call ncvgt(ncid,vid,1,recdim,Arrayv,rcode) ! read data

      if (rcode .ne. 0) then
          print*,'EE error rcode in getting data 2'
          if (StopOnProblem) then
            stop 
          else 
           return
          endif
      endif

!     if (DebugOn) then
!      print*,'Debugtr Getting f_string dim id for flags' 
!     endif

      Dimidforf_string = ncdid(ncid,'f_string',rcode)

      if (rcode .ne. 0) then
         print*,'EE error rcode in getting f_string_dim'
          if (StopOnProblem) then
            stop 
          else 
           return
          endif
      endif

!     if (DebugOn) then
!      print*,'Debugtr Getting f_string size for flags' 
!     endif

      call ncdinq(ncid,Dimidforf_string,TempName,f_string_size,rcode)

      if (rcode .ne. 0) then
          print*,'EE error rcode getting f_string size'
          if (StopOnProblem) then
            stop 
          else 
           return
          endif
      endif

!     if (DebugOn) then
!      print*,'Debugtr Getting qcindex for flags' 
!     endif

      call NCAGT(ncid,vid, 'qcindex',qcindex, rcode)

      if (rcode .ne. 0) then
          print*,'EE error rcode getting qcindex for time'
          if (StopOnProblem) then
            stop 
          else 
           return
          endif
      endif

       if (qcindex .ne. 1) then
         print*,'EE strange, qcindex for time should be 1'
          rcode = -200
          if (StopOnProblem) then
            stop 
          else 
           return
          endif
       endif

!     if (DebugOn) then
!      print*,'Debugtr Getting vid for flag' 
!     endif

      vid=ncvid(ncid,'flag',rcode)
      if (rcode .ne. 0) then
          print*,'EE error rcode in getting vid for flag'
          if (StopOnProblem) then
            stop 
          else 
           return
          endif
      endif

!     if (DebugOn) then
!      print*,'Debugtr loading in data' 
!     endif

      do iii = 1, recdim
           placeofflag(1) = qcindex
           placeofflag(2) = iii
           call ncvg1c(ncid,vid, placeofflag, let, rcode)
           Arrayvflags(iii) = let
           if (rcode .ne. 0) then
             print*,'EE error problem getting flag for element ',iii

             if (StopOnProblem) then
               stop 
             else 
              return
             endif
           endif
      enddo

      endif ! end of if (NameOfPar .eq. 'time') then

!--------------------------------------------------------------------------


      if (NameOfPar .eq. 'date') then

!     if (DebugOn) then
!      print*,'Debugtr Debugtr found and in date block' 
!     endif

      NameOfParFound = .true.

      if (DebugOn) then
       print*,'Debugtr getting vid for date' 
      endif

      vid=ncvid(ncid,'date',rcode)

      if (rcode .ne. 0) then
          print*,'EE error rcode in getting vid for date'
          if (StopOnProblem) then
            stop 
          else 
           return
          endif
      endif

!      if (DebugOn) then
!       print*,'Debugtr Getting Arrayv' 
!      endif

      call ncvgt(ncid,vid,1,recdim,Arrayv,rcode) ! read data

      if (rcode .ne. 0) then
          print*,'EE error rcode in getting date data'
          if (StopOnProblem) then
            stop 
          else 
           return
          endif
      endif

!     if (DebugOn) then
!      print*,'Debugtr Getting f_string dim id for flags' 
!     endif

      Dimidforf_string = ncdid(ncid,'f_string',rcode)

      if (rcode .ne. 0) then
         print*,'EE error rcode in getting f_string_dim'
          if (StopOnProblem) then
            stop 
          else 
           return
          endif
      endif

!     if (DebugOn) then
!      print*,'Debugtr Getting f_string size for flags' 
!     endif

      call ncdinq(ncid,Dimidforf_string,TempName,f_string_size,rcode)

      if (rcode .ne. 0) then
          print*,'EE error rcode getting f_string size'
          if (StopOnProblem) then
            stop 
          else 
           return
          endif
      endif

!     if (DebugOn) then
!      print*,'Debugtr Getting qcindex for flags' 
!     endif

      call NCAGT(ncid,vid, 'qcindex',qcindex, rcode)

       if (qcindex .ne. 1) then
         print*,'EE strange, qcindex for date/time should be 1'
          rcode = -200
          if (StopOnProblem) then
            stop 
          else 
           return
          endif
       endif

      if (rcode .ne. 0) then
          print*,'EE error rcode getting qcindex for date'
          if (StopOnProblem) then
            stop 
          else 
           return
          endif
      endif

!     if (DebugOn) then
!      print*,'Debugtr Getting vid for flag' 
!     endif

      vid=ncvid(ncid,'flag',rcode)
      if (rcode .ne. 0) then
          print*,'EE error rcode in getting vid for flag'
          if (StopOnProblem) then
            stop 
          else 
           return
          endif
      endif

!     if (DebugOn) then
!      print*,'Debugtr loading in data' 
!     endif

      do iii = 1, recdim
           placeofflag(1) = qcindex
           placeofflag(2) = iii
           call ncvg1c(ncid,vid, placeofflag, let, rcode)
           Arrayvflags(iii) = let
           if (rcode .ne. 0) then
             print*,'EE error problem getting flag for element ',iii
             if (StopOnProblem) then
               stop 
             else 
              return
             endif
           endif
      enddo

      endif ! end of if (NameOfPar .eq. 'date') then

!------------------------------------------------------ 

       if (.not. ( NameOfParFound)) then 
         print*,'EE the parameter-',NameOfPar,'- (minus front and end -s) is not '
         print*,' an integer parameter in this program view of v200 files'
          rcode = -200
          if (StopOnProblem) then
            stop 
          else 
           return
          endif
       endif

!     if (DebugOn) then
!      do i=1, recdim
!         print*,'Debugttr ',  Arrayv(i),'   ',Arrayvflags(i),i,NameOfPar
!      enddo
!     endif

!     if (DebugOn) then
!      print*,' Out of getver200intvals '
!     endif

      end subroutine getver200intvals



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


      subroutine getver200fltvals(ncid, NameOfPar,  Arrayv, Arrayvflags, &
         hordv, convU, rcode, DebugTrace,StopOnProb)
      implicit none


!
! hordv is a special thing added late to this specific file since Shawn wants that height
! or depth attribute
!
! Now for version 11 we have another specical thing converse units.  This should be 0-12
! but we add -1 for not there.  

! New for V. 12, we either get ConvU or Type much as we either get height or depth.

      integer, intent(in) :: ncid
      character (Len=12), intent(in) :: NameOfPar ! no par name should be bigger
      real, intent(out), dimension(:)  :: Arrayv
      character, intent(out), dimension(:)  :: Arrayvflags
      integer, optional :: DebugTrace, StopOnProb
      integer :: rcode, vid, qcindex,iii,ijitype, ijilen
      integer :: recdim, ndims, nvars, ngatts ,Dimidfortime

      integer :: Dimidforf_string, f_string_size, tempint1, tempint2, i
      character (Len=31) :: TempName 

      character :: let

      integer, dimension(2) :: placeofflag
      logical DebugOn

      real hordv
      integer ConvU
      !
!     ConvU new for version 11 hordv been around a while (height or depth)

      double precision :: rrr(1)

      integer :: iaval(1)

      logical NameOfParFound, StopOnProblem, isheight

!     we use this to access the flag array; see code below
          
!     Inquire for info on nc file parameters:

      DebugOn = .false.

      isheight = .true.
!     !
!     we get height most often but sometimes depth for water temp vals.

      NameOfParFound =  .false.
      StopOnProblem  =  .true.

      hordv = -9999
      ConvU=-3
      !
!     These are defalut values for these two attributes

!      if (present(DebugTrace)) then
!        if (DebugTrace .eq. 1) then
!         DebugOn = .true.
!        endif
!      endif

      if (present(StopOnProb)) then
        if (StopOnProb .eq. 0) then
         StopOnProblem = .false.
        endif
      endif


!     if (DebugOn) then
!       print*,'into getver200fltvals'
!     endif


!     if (DebugOn) then
!       print*,'Debugtr about to inquire about ', ncid,' time size '
!     endif


      Dimidfortime = ncdid(ncid, 'time', rcode)

       if (rcode .ne. 0) then
          print*,'EE error rcode in getting time dim'
          if (StopOnProblem) then
            stop 
          else 
           return
          endif
       endif

!     if (DebugOn) then
!       print*,'Debugtr about to get time size '
!     endif

      call ncdinq(ncid,Dimidfortime,TempName,recdim,rcode)

!     if (DebugOn) then
!       print*,'time size is ',recdim
!     endif


      if ( rcode .NE. 0 ) then
           print*, 'EE Error in getting info on netcdf data file: ', rcode 
           print*, '   netcdf file has id ',ncid
          if (StopOnProblem) then
            stop 
          else 
           return
          endif 
      endif

!     if (DebugOn) then
!       print*,'Debugtr About to do size Arrayvflags'
!     endif

      if (size(Arrayvflags) .ne. recdim) then
        print*,'EE Arrayvflags should have dimension ',size(Arrayvflags),recdim
          rcode = -200
          if (StopOnProblem) then
            stop 
          else 
           return
          endif
      endif

!     if (DebugOn) then
!       print*,'Debugtr About to do size Arrayv'
!     endif

      if (size(Arrayv) .ne. recdim) then
           print*,'EE Arrayv should have dimension'
           rcode = -200
           if (StopOnProblem) then
             stop 
           else 
            return
           endif
      endif       

!     in string comparisons FORTRAN blank fills the shorter string so this
!     should work, i.e.  'time' .eq. 'time          ' in FORTRAN 90

!      if (DebugOn) then
!       print*,'Debugtr in getver200intvals looking for_ ',NameOfPar 
!      endif

!--------------------------------------------------------------------------

      if (NameOfPar .eq. 'latitude') then

        if (DebugOn) then
         print*,'Debugtr Debugtr found and in latitude block' 
        endif

        NameOfParFound = .true.

        if (DebugOn) then
         print*,'Debugtr getting vid for latitude' 
        endif

        vid=ncvid(ncid,'latitude',rcode)

        if (rcode .ne. 0) then
          print*,'EE latitude problem'
           if (StopOnProblem) then
             stop 
           else 
            return
           endif
        endif

      endif

!&&&

      if (NameOfPar .eq. 'longitude') then

        if (DebugOn) then
         print*,'Debugtr Debugtr found and in longitude block' 
        endif

        NameOfParFound = .true.

        if (DebugOn) then
         print*,'Debugtr getting vid for longitude' 
        endif

        vid=ncvid(ncid,'longitude',rcode)

        if (rcode .ne. 0) then
          print*,'EE longitude problem'
           if (StopOnProblem) then
             stop 
           else 
            return
           endif
        endif

      endif

!&&



    
    
      if (NameOfPar .eq. 'PL_HD') then
         NameOfParFound = .true.
                                
         vid=ncvid(ncid,'PL_HD', rcode)
                       
         if (rcode .ne. 0) then
           return
         endif
      endif
    
    
      if (NameOfPar .eq. 'PL_HD2') then
         NameOfParFound = .true.
                                
         vid=ncvid(ncid,'PL_HD2', rcode)
                                
         if (rcode .ne. 0) then
           return
         endif
      endif
    
    
      if (NameOfPar .eq. 'PL_CRS') then
         NameOfParFound = .true.
                                
         vid=ncvid(ncid,'PL_CRS', rcode)
                                
         if (rcode .ne. 0) then
           return
         endif
      endif
    
    
      if (NameOfPar .eq. 'PL_CRS2') then
         NameOfParFound = .true.
                                
         vid=ncvid(ncid,'PL_CRS2', rcode)
                                
         if (rcode .ne. 0) then
           return
         endif
      endif
    
    
      if (NameOfPar .eq. 'PL_CRS3') then
         NameOfParFound = .true.
                                
         vid=ncvid(ncid,'PL_CRS3', rcode)
                                
         if (rcode .ne. 0) then
           return
         endif
      endif
    
    
      if (NameOfPar .eq. 'PL_SPD') then
         NameOfParFound = .true.
                                
         vid=ncvid(ncid,'PL_SPD', rcode)
                                
         if (rcode .ne. 0) then
           return
         endif
      endif
    
    
      if (NameOfPar .eq. 'PL_SPD2') then
         NameOfParFound = .true.
                                
         vid=ncvid(ncid,'PL_SPD2', rcode)
                                
         if (rcode .ne. 0) then
           return
         endif
      endif
    
    
      if (NameOfPar .eq. 'PL_SPD3') then
         NameOfParFound = .true.
                                
         vid=ncvid(ncid,'PL_SPD3', rcode)
                                
         if (rcode .ne. 0) then
           return
         endif
      endif
    
    
      if (NameOfPar .eq. 'PL_WDIR') then
         NameOfParFound = .true.
                                
         vid=ncvid(ncid,'PL_WDIR', rcode)
                                
         if (rcode .ne. 0) then
           return
         endif
      endif
    
    
      if (NameOfPar .eq. 'PL_WSPD') then
         NameOfParFound = .true.
                                
         vid=ncvid(ncid,'PL_WSPD', rcode)
                                
         if (rcode .ne. 0) then
           return
         endif
      endif
    
    
      if (NameOfPar .eq. 'PL_WDIR2') then
         NameOfParFound = .true.
                                
         vid=ncvid(ncid,'PL_WDIR2', rcode)
                                
         if (rcode .ne. 0) then
           return
         endif
      endif
    
    
      if (NameOfPar .eq. 'PL_WSPD2') then
         NameOfParFound = .true.
                                
         vid=ncvid(ncid,'PL_WSPD2', rcode)
                                
         if (rcode .ne. 0) then
           return
         endif
      endif
    
    
      if (NameOfPar .eq. 'PL_WDIR3') then
         NameOfParFound = .true.
                                
         vid=ncvid(ncid,'PL_WDIR3', rcode)
                                
         if (rcode .ne. 0) then
           return
         endif
      endif
    
    
      if (NameOfPar .eq. 'PL_WSPD3') then
         NameOfParFound = .true.
                                
         vid=ncvid(ncid,'PL_WSPD3', rcode)
                                
         if (rcode .ne. 0) then
           return
         endif
      endif
    
    
      if (NameOfPar .eq. 'DIR') then
         NameOfParFound = .true.
                                
         vid=ncvid(ncid,'DIR', rcode)
                                
         if (rcode .ne. 0) then
           return
         endif
      endif
    
    
      if (NameOfPar .eq. 'SPD') then
         NameOfParFound = .true.
                                
         vid=ncvid(ncid,'SPD', rcode)
                                
         if (rcode .ne. 0) then
           return
         endif
      endif
    
    
      if (NameOfPar .eq. 'DIR2') then
         NameOfParFound = .true.
                                
         vid=ncvid(ncid,'DIR2', rcode)
                                
         if (rcode .ne. 0) then
           return
         endif
      endif
    
    
      if (NameOfPar .eq. 'SPD2') then
         NameOfParFound = .true.
                                
         vid=ncvid(ncid,'SPD2', rcode)
                                
         if (rcode .ne. 0) then
           return
         endif
      endif
    
    
      if (NameOfPar .eq. 'DIR3') then
         NameOfParFound = .true.
                                
         vid=ncvid(ncid,'DIR3', rcode)
                                
         if (rcode .ne. 0) then
           return
         endif
      endif
    
    
      if (NameOfPar .eq. 'SPD3') then
         NameOfParFound = .true.
                                
         vid=ncvid(ncid,'SPD3', rcode)
                                
         if (rcode .ne. 0) then
           return
         endif
      endif
    
    
      if (NameOfPar .eq. 'P') then
         NameOfParFound = .true.
                                
         vid=ncvid(ncid,'P', rcode)
                                
         if (rcode .ne. 0) then
           return
         endif
      endif
    
    
      if (NameOfPar .eq. 'temperature') then
         NameOfParFound = .true.
                                
         vid=ncvid(ncid,'temperature', rcode)

         isheight = .false.
                                
         if (rcode .ne. 0) then
           return
         endif
      endif
    
    
      if (NameOfPar .eq. 'temperature2') then
         NameOfParFound = .true.
                                
         vid=ncvid(ncid,'temperature2', rcode)

         isheight = .false.
                                
         if (rcode .ne. 0) then
           return
         endif
      endif
    
    
      if (NameOfPar .eq. 'temperature3') then
         NameOfParFound = .true.
                                
         vid=ncvid(ncid,'temperature3', rcode)

         isheight = .false.
                                
         if (rcode .ne. 0) then
           return
         endif
      endif
    
    
      if (NameOfPar .eq. 'T') then
         NameOfParFound = .true.
                                
         vid=ncvid(ncid,'T', rcode)
                                
         if (rcode .ne. 0) then
           return
         endif
      endif
    
    
      if (NameOfPar .eq. 'T2') then
         NameOfParFound = .true.
                                
         vid=ncvid(ncid,'T2', rcode)
                                
         if (rcode .ne. 0) then
           return
         endif
      endif
    
    
      if (NameOfPar .eq. 'TW') then
         NameOfParFound = .true.
                                
         vid=ncvid(ncid,'TW', rcode)
                                
         if (rcode .ne. 0) then
           return
         endif
      endif
    
    
      if (NameOfPar .eq. 'TW2') then
         NameOfParFound = .true.
                                
         vid=ncvid(ncid,'TW2', rcode)
                                
         if (rcode .ne. 0) then
           return
         endif
      endif
    
    
      if (NameOfPar .eq. 'TD') then
         NameOfParFound = .true.
                                
         vid=ncvid(ncid,'TD', rcode)
                                
         if (rcode .ne. 0) then
           return
         endif
      endif
    
    
      if (NameOfPar .eq. 'TD2') then
         NameOfParFound = .true.
                                
         vid=ncvid(ncid,'TD2', rcode)
                                
         if (rcode .ne. 0) then
           return
         endif
      endif
    
    
      if (NameOfPar .eq. 'RH') then
         NameOfParFound = .true.
                                
         vid=ncvid(ncid,'RH', rcode)
                                
         if (rcode .ne. 0) then
           return
         endif
      endif
    
    
      if (NameOfPar .eq. 'RH2') then
         NameOfParFound = .true.
                                
         vid=ncvid(ncid,'RH2', rcode)
                                
         if (rcode .ne. 0) then
           return
         endif
      endif
    
    
      if (NameOfPar .eq. 'PRECIP') then
         NameOfParFound = .true.
                                
         vid=ncvid(ncid,'PRECIP', rcode)
                                
         if (rcode .ne. 0) then
           return
         endif
      endif
    
    
      if (NameOfPar .eq. 'RAD') then
         NameOfParFound = .true.
                                
         vid=ncvid(ncid,'RAD', rcode)
                                
         if (rcode .ne. 0) then
           return
         endif
      endif
    
    
      if (NameOfPar .eq. 'RAD2') then
         NameOfParFound = .true.
                                
         vid=ncvid(ncid,'RAD2', rcode)
                                
         if (rcode .ne. 0) then
           return
         endif
      endif
    
    
      if (NameOfPar .eq. 'RAD3') then
         NameOfParFound = .true.
                                
         vid=ncvid(ncid,'RAD3', rcode)
                                
         if (rcode .ne. 0) then
           return
         endif
      endif
    
    
      if (NameOfPar .eq. 'Q') then
         NameOfParFound = .true.
                                
         vid=ncvid(ncid,'Q', rcode)
                                
         if (rcode .ne. 0) then
           return
         endif
      endif
    
    
      if (NameOfPar .eq. 'Q2') then
         NameOfParFound = .true.
                                
         vid=ncvid(ncid,'Q2', rcode)
                                
         if (rcode .ne. 0) then
           return
         endif
      endif
    
    
      if (NameOfPar .eq. 'RRATE') then
         NameOfParFound = .true.
                                
         vid=ncvid(ncid,'RRATE', rcode)
                                
         if (rcode .ne. 0) then
           return
         endif
      endif


      if (NameOfPar .eq. 'latitude2') then
         NameOfParFound = .true.

!         write(*,*)' here we go'                                
         vid=ncvid(ncid,'latitude2', rcode)
!         write(*,*)' that was it'
                                
         if (rcode .ne. 0) then
           return
         endif
      endif


      if (NameOfPar .eq. 'longitude2') then
         NameOfParFound = .true.
                                
         vid=ncvid(ncid,'longitude2', rcode)
                                
         if (rcode .ne. 0) then
           return
         endif
      endif
    
    
      if (NameOfPar .eq. 'NONE') then
         NameOfParFound = .true.
                                
         vid=ncvid(ncid,'NONE', rcode)
                                
         if (rcode .ne. 0) then
           return
         endif
      endif

      if (.not. ( NameOfParFound)) then 
         rcode = -200
	 err_flag = 1
	 write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
         write(*,*)'ERROR: PARAMETER ',NameOfPar,' IS NOT A FLOAT PARAMETER'
         write(*,*)'       IN THIS VERSION OF v200 FILES'
	 write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
	 write(err_file,*)'ERROR: PARAMETER ',NameOfPar,' IS NOT A FLOAT PARAMETER'
         write(err_file,*)'IN THIS VERSION OF v200 FILES'
         stop
      endif

!      if (DebugOn) then
!       print*,'Debugtr Getting Arrayv' 
!      endif

      if (isheight ) then

        call ncainq(ncid, vid, 'height',ijitype,ijilen, rcode)

        if (rcode .eq. 0) then

          if (.not.((ijitype.eq.NCFLOAT).or.(ijitype.eq.NCDOUBLE))) then
	    err_flag = 1
	    write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
            write(*,*)'ERROR: VARIABLE TYPE NOT FLOAT OR DOUBLE TYPE ATTRIBUTE'
	    write(*,*)'       FOR ', vid
	    write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
	    write(err_file,*)'ERROR: VARIABLE TYPE NOT FLOAT OR DOUBLE TYPE ATTRIBUTE'
	    write(err_file,*)'FOR ', vid
            stop
          endif

          if (ijitype .eq. NCDOUBLE) then
            call ncagt(ncid, vid, 'height', rrr, rcode)
            !
!           rrr is a one element array.  Strange, but the netcdf documentation
!           wants an array always so to be on the safe side I send it one.  It
!           may well work with just a real variable here.

!            write(*,*) NameOfPar,' has h',rrr(1),' at end ',rcode
            hordv = rrr(1)
          else
            call ncagt(ncid, vid, 'height',rrr,rcode)
            hordv = rrr(1)
	    err_flag = 1
	    write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
            write(*,*)'WARNING: ', NameOfPar,' HAS FLOATING HEIGHT VALUE ',hordv
            write(*,*)'        EXPECTED A DOUBLE HEIGHT VALUE.'
	    write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
	    write(err_file, *) 'WARNING: ', NameOfPar,' HAS FLOATING HEIGHT VALUE ',hordv
	    write(err_file, *)'EXPECTED A DOUBLE HEIGHT VALUE.'
          endif
        endif
      else

        call ncainq(ncid, vid, 'depth',ijitype, ijilen, rcode)

        if (rcode .eq. 0) then
          if (.not.((ijitype.eq.NCFLOAT).or.(ijitype.eq.NCDOUBLE))) then
	    err_flag = 1
	    write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
            write(*,*)'ERROR: VARIABLE TYPE NOT FLOAT OR DOUBLE TYPE ATTRIBUTE'
	    write(*,*)'       FOR ', vid
	    write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
	    write(err_file,*)'ERROR: VARIABLE TYPE NOT FLOAT OR DOUBLE TYPE ATTRIBUTE'
	    write(err_file,*)'FOR ', vid
            stop
          endif
          if (ijitype .eq. NCDOUBLE) then
            call ncagt(ncid, vid, 'depth', rrr, rcode)
!            write(*,*) NameOfPar,' has d',rrr(1),' at end ',rcode
            hordv = rrr(1)
          else
            call ncagt(ncid, vid, 'depth',rrr,rcode)
            hordv = rrr(1)
	    err_flag = 1
	    write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
            write(*,*)'WARNING: ', NameOfPar,' HAS FLOATING HEIGHT VALUE ',hordv
            write(*,*)'        EXPECTED A DOUBLE HEIGHT VALUE.'
	    write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
	    write(err_file, *) 'WARNING: ', NameOfPar,' HAS FLOATING HEIGHT VALUE ',hordv
	    write(err_file, *)'EXPECTED A DOUBLE HEIGHT VALUE.'
          endif
        endif
      endif
      !
!     one or the other as applies

      if (rcode .ne. 0) then
       hordv = -9999
      endif

!     this is new V. 11 and then changed for V. 12 

      if (isheight ) then
      !
!     we get height/depth convers or type depending on value of isheight
!     which is set above

        call ncainq(ncid, vid, 'convers_units',ijitype,ijilen, rcode)

        if (rcode .eq. 0) then
          if (.not.((ijitype.eq.NCSHORT).or.(ijitype.eq.NCLONG))) then
	    err_flag = 1
	    write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
            write(*,*)'ERROR: VARIABLE TYPE NOT SHORT OR LONG TYPE ATTRIBUTE'
	    write(*,*)'       FOR ', vid
	    write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
	    write(err_file,*)'ERROR: VARIABLE TYPE NOT SHORT OR LONG TYPE ATTRIBUTE'
	    write(err_file,*)'FOR ', vid
            stop
          endif

          if (ijitype .eq. NCLONG) then
            call ncagt(ncid, vid, 'convers_units', iaval, rcode)
            ConvU = iaval(1)
!            write(*,*) NameOfPar,' has converse ',ConvU,' at end ',rcode
          else
            call ncagt(ncid, vid, 'convers_units', iaval, rcode)
            ConvU = iaval(1)
	    err_flag = 1
	    write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
            write(*,*)'WARNING: ', NameOfPar,' HAS SHORT CONVERSION VALUE ',ConvU
            write(*,*)'        EXPECTED A LONG CONVERSION VALUE.'
	    write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
	    write(err_file, *) 'WARNING: ', NameOfPar,' HAS SHORT CONVERSION VALUE ',ConvU
	    write(err_file, *)'EXPECTED A LONG CONVERSION VALUE.'
          endif
        endif
      else     ! else of       if (isheight ) then
        call ncainq(ncid, vid, 'type',ijitype, ijilen, rcode)

        if (rcode .eq. 0) then
          if (.not.((ijitype.eq.NCSHORT).or.(ijitype.eq.NCLONG))) then
	    err_flag = 1
	    write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
            write(*,*)'ERROR: VARIABLE TYPE NOT SHORT OR LONG TYPE ATTRIBUTE'
	    write(*,*)'       FOR ', vid
	    write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
	    write(err_file,*)'ERROR: VARIABLE TYPE NOT SHORT OR LONG TYPE ATTRIBUTE'
	    write(err_file,*)'FOR ', vid
            stop
          endif
          if (ijitype .eq. NCLONG) then
            call ncagt(ncid, vid, 'type',       iaval, rcode)
            ConvU = iaval(1)
            !
!           We get type but we just treat it as a conversion unit

!            write(*,*) NameOfPar,' has type',ConvU,' at end ',rcode

          else
            call ncagt(ncid, vid, 'type',       iaval, rcode)
            ConvU = iaval(1)
	    err_flag = 1
	    write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
            write(*,*)'WARNING: ', NameOfPar,' HAS SHORT CONVERSION VALUE ',ConvU
            write(*,*)'        EXPECTED A LONG CONVERSION VALUE.'
	    write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
	    write(err_file, *) 'WARNING: ', NameOfPar,' HAS SHORT CONVERSION VALUE ',ConvU
	    write(err_file, *)'EXPECTED A LONG CONVERSION VALUE.'
          endif
        endif
      endif
      !
!     one or the other as applies

      if (rcode .ne. 0) then
       ConvU = -3
      endif


! end new for version 11 but changed for 12

      call ncvgt(ncid,vid,1,recdim,Arrayv,rcode) ! read data

      if (rcode .ne. 0) then
          print*,'EE error rcode in getting data 1'
           if (StopOnProblem) then
             stop 
           else 
            return
           endif
      endif

!     if (DebugOn) then
!      print*,'Debugtr Getting f_string dim id for flags' 
!     endif

      Dimidforf_string = ncdid(ncid,'f_string',rcode)

      if (rcode .ne. 0) then
         print*,'EE error rcode in getting f_string_dim'
         if (StopOnProblem) then
             stop 
         else 
            return
         endif
      endif

!     if (DebugOn) then
!      print*,'Debugtr Getting f_string size for flags' 
!     endif

      call ncdinq(ncid,Dimidforf_string,TempName,f_string_size,rcode)

      if (rcode .ne. 0) then
          print*,'EE error rcode getting f_string size'
           if (StopOnProblem) then
             stop 
           else 
            return
           endif
      endif

!     if (DebugOn) then
!      print*,'Debugtr Getting qcindex for flags' 
!     endif

      call NCAGT(ncid,vid, 'qcindex',qcindex, rcode)

      if (rcode .ne. 0) then
          print*,'EE error rcode getting qcindex for time'
          if (StopOnProblem) then
             stop 
          else 
            return
          endif
      endif

!     if (DebugOn) then
!      print*,'Debugtr Getting vid for flag' 
!     endif

      vid=ncvid(ncid,'flag',rcode)
      if (rcode .ne. 0) then
          print*,'EE error rcode in getting vid for flag'
           if (StopOnProblem) then
             stop 
           else 
            return
           endif
      endif

!     if (DebugOn) then
!      print*,'Debugtr loading in data' 
!     endif

      do iii = 1, recdim
           placeofflag(1) = qcindex
           placeofflag(2) = iii
           call ncvg1c(ncid,vid, placeofflag, let, rcode)
           Arrayvflags(iii) = let
           if (rcode .ne. 0) then
             print*,'EE error problem getting flag for element ',iii
            if (StopOnProblem) then
              stop 
            else 
             return
            endif
           endif
      enddo

      end subroutine getver200fltvals

!      END NETCDF Version 200 Read routines  :::::::::::::::::






      subroutine FMissing( NameOfPar, Arrayv, Arrayvflags, rcode, DebugTrace)

      character (Len=12), intent(in) :: NameOfPar ! no par name should be bigger
      real, intent(out), dimension(:)  :: Arrayv
      character, intent(out), dimension(:)  :: Arrayvflags
      integer i,j,k
      integer, optional :: DebugTrace
      integer, intent(in) :: rcode

      if (present(DebugTrace)) then
        if (DebugTrace .eq. 1) then
         print*,'FillsInMiss ',rcode,NameOfPar
        endif
      endif

      if (rcode .ne. 0) then
        do i = 1, size(arrayv)
          arrayv(i) = -19999.9
          Arrayvflags(i) = 'K'
        enddo
      endif

      return
      end subroutine

      end
